#!/usr/bin/perl

my $hostname = $ARGV[0];
my $arg1 = $ARGV[1];
my $arg2 = $ARGV[2];
my $arg3 = $ARGV[3];
my $localfile = "/var/tmp/cacti/$hostname.ctl.txt";

$remotedir = "/tmp/hitachi_stats/";

#GET STATS if local file is older than a few seconds
if (-e $localfile) {
	if (-M $localfile > ".001") {
	$getstats = "yes";
	} else {
	$getstats = "no";
	#print "old";
	}
} else {
$getstats = "yes";
}


### COMMENT BOTH
#$getstats = "yes";
#print "getting stats every time!\n";

# Getstats if we need them
if ($getstats =~ /yes/) {

# define stats array.
my %cluster = ();

#Get newest file
#$remotefile = `find $remotedir -type f -mmin -5`;
$remotefile = `find $remotedir -type f -mmin -5`;
#print $remotefile;
$start1 = "no";
$start2 = "no";

#Parse file line by line
   open (RG, "<$remotefile");
   while ($rgline = <RG>) {
   chop $rgline;
	$rgline =~ s/^\s+//;
	$rgline =~ s/\s+$//; 
#print $rgline."\n";
#split the lines into an array
       my @rgsplit = split(/\s+/, $rgline);

	if ($rgsplit[0] =~ /^\-\-\-\-/) {
	$data = "no";
	$sectionstart = "yes";
	$header = "no";
	$section = $rgline;
	$section =~ s/\-+//g;  # Replace all -'s
	$section =~ s/^\s+//;  # Trim leading
	$section =~ s/\s+$//;  # Trim trailing spaces
	$section =~ s/\s/_/g;  # Replace all spaces
#	print $section."\n";
	} 



### END COMMON SCRIPT

## BEGIN  CTL MOD

	if ($rgsplit[0] =~ /CTL/) {
	$data = "no";
	$sectionstart = "no";
	$header = "yes";
		if ($rgline =~ /Rate/) {
		$subsection = $rgline;
#		print $subsection."\n";		
		}
	}


 
	if (($rgsplit[0] =~ /0/) || ($rgsplit[0] =~ /1/)) {
	$data = "yes";
        $sectionstart = "no";
        $header = "no";
	$ctl = "CTL"."$rgsplit[0]";

           if (($section =~ /Cache_Information/) && ($subsection =~ /Write Pending/)) {
           	if ($subsection =~ /Partition/) {
#		$cluster{$ctl.$rgsplit[1]}{'WritePending'} += $rgsplit[2];
		} else {
		$cluster{$ctl}{'WritePending'} += $rgsplit[1];
		}
	    }
            if (($section =~ /Cache_Information/) && ($subsection =~ /Clean Queue/)) {

            	if ($subsection =~ /Partition/) {

			} else {
			$cluster{$ctl}{'CleanQueueUsage'} += $rgsplit[1];
			$cluster{$ctl}{'MiddleQueueUsage'} += $rgsplit[2];
			$cluster{$ctl}{'PhysicalQueueUsage'} += $rgsplit[3];
			}
   	       }
	
           if (($section =~ /Processor_Information/) && ($subsection =~ /Usage/)) {
           	if ($subsection =~ /Cache/) {
		} else {
			if ($rgsplit[1] =~ /X/) {
			$cluster{$ctl}{'CPU'} += $rgsplit[2];
			} else {
			$cluster{$ctl}{'CPU'} += $rgsplit[1];
			}
		}
           	if ($subsection =~ /Cache Bus/) {
			$cluster{$ctl}{'HostCacheBusUsage'} += $rgsplit[1];
			$cluster{$ctl}{'DriveCacheBusUsage'} += $rgsplit[2];
			$cluster{$ctl}{'ProcessorCacheBusUsage'} += $rgsplit[3];
		}
           	if ($subsection =~ /Total Bus/) {
			$cluster{$ctl}{'DDRBusUsage'} += $rgsplit[1];
			$cluster{$ctl}{'DualBusUsage'} += $rgsplit[2];
			$cluster{$ctl}{'TotalBusUsage'} += $rgsplit[3];
		}
	    }

	} else {
	

	} 
    }

#Now write the array to the local file
   open (STATDB, ">$localfile");
   foreach $ctl (sort keys %cluster) {
	#DONT WRITE THE BOGUS HEADER LINES
#       if (($rg =~ /RGRG/) or ($rg =~ /CTLCTL/) or ($rg =~ /RGA/) or ($rg =~ /RGB/) or ($rg =~ /CTL\-/) or ($rg =~ /RGP/)) {
#	} else {
       print STATDB "$ctl:$cluster{$ctl}{'WritePending'}:$cluster{$ctl}{'CleanQueueUsage'}:$cluster{$ctl}{'MiddleQueueUsage'}:$cluster{$ctl}{'PhysicalQueueUsage'}:$cluster{$ctl}{'CPU'}:$cluster{$ctl}{'TotalBusUsage'}:$cluster{$ctl}{'DualBusUsage'}:$cluster{$ctl}{'DDRBusUsage'}:$cluster{$ctl}{'ProcessorCacheBusUsage'}:$cluster{$ctl}{'DriveCacheBusUsage'}:$cluster{$ctl}{'HostCacheBusUsage'}\n";
#	}
   }
   close (STATDB);

} else {
}

#Now return results
if ($arg1 eq "index") {
print `cat $localfile | awk -F: '{print \$1}'`;
}


if (($arg1 eq "query") && ($arg2 eq "index")) {
print `cat $localfile | awk -F: '{print \$1 \":\" \$1}'`;
}

if ($arg1 eq "query") {
        if ($arg2 =~ /WritePending/) {
        $line=`cat $localfile | awk -F: '{print \$1 \":\" \$2}'`;
        } elsif ($arg2 =~ /CleanQueueUsage/) {
        $line=`cat $localfile | awk -F: '{print \$1 \":\" \$3}'`;
        } elsif ($arg2 =~ /MiddleQueueUsage/) {
        $line=`cat $localfile | awk -F: '{print \$1 \":\" \$4}'`;
        } elsif ($arg2 =~ /PhysicalQueueUsage/) {
        $line=`cat $localfile | awk -F: '{print \$1 \":\" \$5}'`;
        } elsif ($arg2 =~ /CPU/) {
        $line=`cat $localfile | awk -F: '{print \$1 \":\" \$6}'`;
        } elsif ($arg2 =~ /TotalBusUsage/) {
        $line=`cat $localfile | awk -F: '{print \$1 \":\" \$7}'`;
        } elsif ($arg2 =~ /DualBusUsage/) {
        $line=`cat $localfile | awk -F: '{print \$1 \":\" \$8}'`;
        } elsif ($arg2 =~ /DDRBusUsage/) {
        $line=`cat $localfile | awk -F: '{print \$1 \":\" \$9}'`;
        } elsif ($arg2 =~ /ProcessorCacheBusUsage/) {
        $line=`cat $localfile | awk -F: '{print \$1 \":\" \$10}'`;
        } elsif ($arg2 =~ /DriveCacheBusUsage/) {
        $line=`cat $localfile | awk -F: '{print \$1 \":\" \$11}'`;
        } elsif ($arg2 =~ /HostCacheBusUsage/) {
        $line=`cat $localfile | awk -F: '{print \$1 \":\" \$12}'`;
        }
$line =~ s/\s+$//;
print $line;
}

if (($arg1 eq "query") && ($arg2 eq "desc")) {
print `cat $localfile | awk -F: '{print \$1 \":\" \$1}'`;
}

if ($arg1 eq "get") {
	if ($arg2 =~ /WritePending/) { 
	$line=`cat $localfile |  grep ^$arg3: | awk -F: '{print \$2}'`;
	} elsif ($arg2 =~ /CleanQueueUsage/) {
	$line=`cat $localfile |  grep ^$arg3: | awk -F: '{print \$3}'`;
	} elsif ($arg2 =~ /MiddleQueueUsage/) {
	$line=`cat $localfile |  grep ^$arg3: | awk -F: '{print \$4}'`;
	} elsif ($arg2 =~ /PhysicalQueueUsage/) {
	$line=`cat $localfile |  grep ^$arg3: | awk -F: '{print \$5}'`;
	} elsif ($arg2 =~ /CPU/) {
	$line=`cat $localfile |  grep ^$arg3: | awk -F: '{print \$6}'`;
	} elsif ($arg2 =~ /TotalBusUsage/) {
	$line=`cat $localfile |  grep ^$arg3: | awk -F: '{print \$7}'`;
	} elsif ($arg2 =~ /DualBusUsage/) {
	$line=`cat $localfile |  grep ^$arg3: | awk -F: '{print \$8}'`;
	} elsif ($arg2 =~ /DDRBusUsage/) {
	$line=`cat $localfile |  grep ^$arg3: | awk -F: '{print \$9}'`;
	} elsif ($arg2 =~ /ProcessorCacheBusUsage/) {
	$line=`cat $localfile |  grep ^$arg3: | awk -F: '{print \$10}'`;
	} elsif ($arg2 =~ /DriveCacheCacheBusUsage/) {
	$line=`cat $localfile |  grep ^$arg3: | awk -F: '{print \$11}'`;
	} elsif ($arg2 =~ /HostCacheBusUsage/) {
	$line=`cat $localfile |  grep ^$arg3: | awk -F: '{print \$12}'`;
	}
$line =~ s/\s+$//;
print $line;
}

