#!/usr/bin/perl

my $hostname = $ARGV[0];
my $arg1 = $ARGV[1];
my $arg2 = $ARGV[2];
my $arg3 = $ARGV[3];
my $localfile = "/var/tmp/cacti/$hostname.txt";

$remotedir = "/tmp/hitachi_stats/";

#GET STATS if local file is older than a few seconds
if (-e $localfile) {
	if (-M $localfile > ".001") {
	$getstats = "yes";
	} else {
	$getstats = "no";
	}
} else {
$getstats = "yes";
}

# Getstats if we need them
if ($getstats =~ /yes/) {

# define stats array.
my %cluster = ();

#Get newest file
$remotefile = `find $remotedir -type f -mmin -5`;
$start1 = "no";
$start2 = "no";

#Parse file line by line
   open (RG, "<$remotefile");
   while ($rgline = <RG>) {
   chop $rgline;
	$rgline =~ s/^\s+//;
	$rgline =~ s/\s+$//; 
	$rgline =~ s/DP\sPool/DP/g;  # Remove the annoying extra word Pool

#split the lines into an array
       my @rgsplit = split(/\s+/, $rgline);

	if ($rgsplit[0] =~ /\-\-\-\-/) {
	$data = "no";
	$sectionstart = "yes";
	$header = "no";
	$section = $rgline;
	$section =~ s/\-+//g;  # Replace all -'s
	$section =~ s/^\s+//;  # Trim leading
	$section =~ s/\s+$//;  # Trim trailing spaces
	$section =~ s/\s/_/g;  # Replace all spaces

#	print $section."\n";
	} 
	if ($rgsplit[0] =~ /CTL/) {
	$data = "no";
	$sectionstart = "no";
	$header = "yes";
	
		if (($section =~ /RG_Information/) || ($section =~ /LU_Information/) || ($section =~ /DP_Information/) || ($section =~ /Port_Information/)) {
			if ($rgsplit[2] =~ /IO/) {
			$subsection = "IO";
			} elsif (($rgsplit[2] =~ /Read/) && ($rgsplit[4] =~ /Count/)) {			
			#} elsif ($rgsplit[2] =~ /Read/) {			
			$subsection = "RATES";
			}
			elsif (($rgsplit[2] =~ /CTL/) && ($rgsplit[3] =~ /CMD/)) {			
			$subsection = "Port-CTL-CMD";
			}
			elsif (($rgsplit[2] =~ /DATA/) && ($rgsplit[3] =~ /CMD/)) {			
			$subsection = "Port-Data-CMD";
			}
			elsif (($rgsplit[2] =~ /Random/) && ($rgsplit[3] =~ /IO/)) {			
			$subsection = "RG-RandomI-O";
			}
			elsif (($rgsplit[2] =~ /Random/) && ($rgsplit[4] =~ /CMD/)) {			
			$subsection = "RG-RandomCMD";
			}
			elsif (($rgsplit[2] =~ /Sequential/) && ($rgsplit[4] =~ /Rate/)) {			
			$subsection = "RG-SEQRATE";
			}
			elsif (($rgsplit[2] =~ /Sequential/) && ($rgsplit[4] =~ /CMD/)) {			
			$subsection = "SR-GEQCMD";
			}
			elsif (($rgsplit[2] =~ /XCOPY/) && ($rgsplit[3] =~ /Rate/)) {			
			$subsection = "RGxcopyRate";
			}
			elsif (($rgsplit[2] =~ /XCOPY/) && ($rgsplit[3] =~ /Time/)) {			
			$subsection = "RGxcopyTime";
			}
			elsif (($rgsplit[2] =~ /Read/) && ($rgsplit[5] =~ /Count2/)) {			
			$subsection = "LUCount2";
			}
		#print $subsection."\n";		

		}
	} 
	if (($rgsplit[0] =~ /0/) || ($rgsplit[0] =~ /1/)) {
	$data = "yes";
        $sectionstart = "no";
        $header = "no";
            if (($section =~ /RG_Information/) && ($subsection =~ /IO/)) {
	#	print "processing\n";
               $ctl = "CTL"."$rgsplit[0]";
               $rg = "RG".sprintf("%02d",$rgsplit[1]);
               #Keep each raid groups stats together
               $cluster{$rg}{'IOPS'} += $rgsplit[2];


                #and also add each controllers stats together
                $cluster{$ctl}{'IOPS'} += $rgsplit[2];


		}
            if (($section =~ /RG_Information/) && ($subsection =~ /RATES/)) {
	#	print "processing\n";
	        $ctl = "CTL"."$rgsplit[0]";
	        $rg = "RG".sprintf("%02d",$rgsplit[1]);
               $cluster{$rg}{'Reads'} += $rgsplit[2];
               $cluster{$rg}{'Writes'} += $rgsplit[3];
               $cluster{$rg}{'ReadMisses'} += $rgsplit[2]-$rgsplit[4];
               $cluster{$rg}{'WriteMisses'} += $rgsplit[3]-$rgsplit[5];
	        $cluster{$rg}{'ReadTransRate'} += $rgsplit[6];
	        $cluster{$rg}{'WriteTransRate'} += $rgsplit[7];
	        $cluster{$ctl}{'ReadTransRate'} += $rgsplit[6];
	        $cluster{$ctl}{'WriteTransRate'} += $rgsplit[7];
                $cluster{$ctl}{'Reads'} += $rgsplit[2];
                $cluster{$ctl}{'Writes'} += $rgsplit[3];
                $cluster{$ctl}{'ReadMisses'} += $rgsplit[2]-$rgsplit[4];
                $cluster{$ctl}{'WriteMisses'} += $rgsplit[3]-$rgsplit[5];            
	    	}
            
		if (($section =~ /Port_Information/) && ($subsection =~ /IO/)) {
		#print "processing\n";
		#print "rgsplit  ".$rgsplit[1]." -> ".$rgsplit[2]."\n";
               $ctl = "CTL"."$rgsplit[0]";
               $rg = "Port-".$rgsplit[1];			   
               #Keep each raid groups stats together
               $cluster{$rg}{'IOPS'} += $rgsplit[2];


                #and also add each controllers stats together
                $cluster{$ctl}{'IOPS'} += $rgsplit[2];


		}
        if (($section =~ /Port_Information/) && ($subsection =~ /RATES/)) {
		#print "processing\n";
		#print "rgsplit  ".$rgsplit[1]." -> ".$rgsplit[2]."\n";
	        $ctl = "CTL"."$rgsplit[0]";
	        $rg = "Port-".$rgsplit[1];			
               $cluster{$rg}{'Reads'} += $rgsplit[2];
               $cluster{$rg}{'Writes'} += $rgsplit[3];
               $cluster{$rg}{'ReadMisses'} += $rgsplit[2]-$rgsplit[4];
               $cluster{$rg}{'WriteMisses'} += $rgsplit[3]-$rgsplit[5];
	        $cluster{$rg}{'ReadTransRate'} += $rgsplit[6];
	        $cluster{$rg}{'WriteTransRate'} += $rgsplit[7];
	        $cluster{$ctl}{'ReadTransRate'} += $rgsplit[6];
	        $cluster{$ctl}{'WriteTransRate'} += $rgsplit[7];
                $cluster{$ctl}{'Reads'} += $rgsplit[2];
                $cluster{$ctl}{'Writes'} += $rgsplit[3];
                $cluster{$ctl}{'ReadMisses'} += $rgsplit[2]-$rgsplit[4];
                $cluster{$ctl}{'WriteMisses'} += $rgsplit[3]-$rgsplit[5];            
	   }
	   
		if (($section =~ /DP_Information/) && ($subsection =~ /IO/)) {
        #       print "processing\n";
               $ctl = "CTL"."$rgsplit[0]";
               $dp = "DP".sprintf("%03d",$rgsplit[1]);
               #Keep each raid groups stats together
               $cluster{$dp}{'IOPS'} += $rgsplit[2];
                }

            if (($section =~ /LU_Information/) && ($subsection =~ /IO/)) {
        #       print "processing\n";
               $ctl = "CTL"."$rgsplit[0]";
               $lu = "LU".sprintf("%03d",$rgsplit[1]);
               #Keep each raid groups stats together
               $cluster{$lu}{'IOPS'} += $rgsplit[2];
                }

            if (($section =~ /DP_Information/) && ($subsection =~ /RATES/)) {
        #       print "processing\n";
                $ctl = "CTL"."$rgsplit[0]";
                $dp = "DP".sprintf("%03d",$rgsplit[1]);
               $cluster{$dp}{'Reads'} += $rgsplit[2];
               $cluster{$dp}{'Writes'} += $rgsplit[3];
               $cluster{$dp}{'ReadMisses'} += $rgsplit[2]-$rgsplit[4];
               $cluster{$dp}{'WriteMisses'} += $rgsplit[3]-$rgsplit[5];
                $cluster{$dp}{'ReadTransRate'} += $rgsplit[6];
                $cluster{$dp}{'WriteTransRate'} += $rgsplit[7];
                }

            if (($section =~ /LU_Information/) && ($subsection =~ /RATES/)) {
        #       print "processing\n";
                $ctl = "CTL"."$rgsplit[0]";
                $lu = "LU".sprintf("%03d",$rgsplit[1]);
               $cluster{$lu}{'Reads'} += $rgsplit[2];
               $cluster{$lu}{'Writes'} += $rgsplit[3];
               $cluster{$lu}{'ReadMisses'} += $rgsplit[2]-$rgsplit[4];
               $cluster{$lu}{'WriteMisses'} += $rgsplit[3]-$rgsplit[5];
                $cluster{$lu}{'ReadTransRate'} += $rgsplit[6];
                $cluster{$lu}{'WriteTransRate'} += $rgsplit[7];
                }
	} 
    }

#Now write the array to the local file
   open (STATDB, ">$localfile");
   foreach $rg (sort keys %cluster) {
	#DONT WRITE THE BOGUS HEADER LINES
       if (($rg =~ /RGRG/) or ($rg =~ /CTLCTL/) or ($rg =~ /RGA/) or ($rg =~ /RGB/) or ($rg =~ /CTL\-/) or ($rg =~ /RGP/)) {
	} else {
       print STATDB "$rg:$cluster{$rg}{'IOPS'}:$cluster{$rg}{'Reads'}:$cluster{$rg}{'Writes'}:$cluster{$rg}{'ReadMisses'}:$cluster{$rg}{'WriteMisses'}:$cluster{$rg}{'ReadTransRate'}:$cluster{$rg}{'WriteTransRate'}\n";
	}
   }
   close (STATDB);

} else {
}

#Now return results
if ($arg1 eq "index") {
print `cat $localfile | awk -F: '{print \$1}'`;
}


if (($arg1 eq "query") && ($arg2 eq "index")) {
print `cat $localfile | awk -F: '{print \$1 \":\" \$1}'`;
}

if ($arg1 eq "query") {
        if ($arg2 =~ /IOPS/) {
        $line=`cat $localfile | awk -F: '{print \$1 \":\" \$2}'`;
        } elsif ($arg2 =~ /Reads/) {
        $line=`cat $localfile | awk -F: '{print \$1 \":\" \$3}'`;
        } elsif ($arg2 =~ /Writes/) {
        $line=`cat $localfile | awk -F: '{print \$1 \":\" \$4}'`;
        } elsif ($arg2 =~ /ReadMisses/) {
        $line=`cat $localfile | awk -F: '{print \$1 \":\" \$5}'`;
        } elsif ($arg2 =~ /WriteMisses/) {
        $line=`cat $localfile | awk -F: '{print \$1 \":\" \$6}'`;
        } elsif ($arg2 =~ /ReadTransRate/) {
        $line=`cat $localfile | awk -F: '{print \$1 \":\" \$7}'`;
        } elsif ($arg2 =~ /WriteTransRate/) {
        $line=`cat $localfile | awk -F: '{print \$1 \":\" \$8}'`;
        }
$line =~ s/\s+$//;
print $line;
}

if (($arg1 eq "query") && ($arg2 eq "desc")) {
print `cat $localfile | awk -F: '{print \$1 \":\" \$1}'`;
}

if ($arg1 eq "get") {
	if ($arg2 =~ /IOPS/) { 
	$line=`cat $localfile |  grep ^$arg3: | awk -F: '{print \$2}'`;
	} elsif ($arg2 =~ /Reads/) {
	$line=`cat $localfile |  grep ^$arg3: | awk -F: '{print \$3}'`;
	} elsif ($arg2 =~ /Writes/) {
	$line=`cat $localfile |  grep ^$arg3: | awk -F: '{print \$4}'`;
	} elsif ($arg2 =~ /ReadMisses/) {
	$line=`cat $localfile |  grep ^$arg3: | awk -F: '{print \$5}'`;
	} elsif ($arg2 =~ /WriteMisses/) {
	$line=`cat $localfile |  grep ^$arg3: | awk -F: '{print \$6}'`;
	} elsif ($arg2 =~ /ReadTransRate/) {
	$line=`cat $localfile |  grep ^$arg3: | awk -F: '{print \$7}'`;
	} elsif ($arg2 =~ /WriteTransRate/) {
	$line=`cat $localfile |  grep ^$arg3: | awk -F: '{print \$8}'`;
	}
$line =~ s/\s+$//;
print $line;
}

